/**
 * Copyright (C) 2015 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var RE = {};

// 这里存放多语言翻译
RE.localizationText = {
  edit: "编辑",
  switchCard: "切换为卡片",
  switchLink: "切换为链接",
};

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0
};

RE.editor = document.getElementById('editor');
RE.linkBgColor;

document.addEventListener("selectionchange", function() {
 RE.backuprange();
 var selection = window.getSelection();
     if (selection.rangeCount > 0) {
      callback.selectionChange(RE.getCurrentNodeName())
  		RE.detectTextState();
     }

 });

 RE.editor.addEventListener('click',function() {
          			RE.detectTextState();
          			RE.onClick();
 });

 document.addEventListener('touchend',function() {
   			RE.detectTextState();
 });


RE.getCurrentNodeName = function() {
  var selection = window.getSelection();
       if (selection.rangeCount > 0) {
        return selection.getRangeAt(0).commonAncestorContainer.parentNode.nodeName
       }
      return "empty"
};

// Initializations
RE.callback = function() {
    window.location.href = "re-callback://" + encodeURIComponent(RE.getHtml());
}


RE.setHtml = function(contents) {
    RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));

     var videoTags = $(".video-wrap");
    if(videoTags) {
        for (var i = 0, max = videoTags.length; i < max; i++) {
            (function (j) {
              var blockId = videoTags[j].getAttribute("id");
              videoTags[j].setAttribute('contenteditable','false');
              RE.changeVideoCover(blockId,function(){
                callback.changeVideoCover(blockId);
              });

               RE.closeVideo(blockId,function() {
                        callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
               });
            })(i)
        }
    }

    var linkCard = $('.card');
    if(linkCard) {
        if(linkCard[0]) {
           RE.colorHexc(linkCard[0].style.backgroundColor);
        }
      var cardCloseBtn = linkCard.find('.close-btn');
      var jsEditorLinkButton = document.querySelector('.js-editor-link-button');
      var jsEditorCardButton = document.querySelector('.js-editor-card-button');
      for (var i = 0; i < cardCloseBtn.length; i++) {
         cardCloseBtn.eq(i).on('click', function () {
            $(this).closest('.card').remove();
            jsEditorLinkButton.style.display = 'none';
            jsEditorCardButton.style.display = 'none';
           })
      }
    }

     var appBlocks = $('.app-wrap');
     if(appBlocks) {
      for(var i = 0; i < appBlocks.length; i++) {
          appBlocks[i].setAttribute('contenteditable','false');
        }
     }


}

RE.colorHexc = function (colorval) {
    var parts = colorval.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
     delete(parts[0]);
     for (var i = 1; i <= 3; ++i) {
        parts[i] = parseInt(parts[i]).toString(16);
        if (parts[i].length == 1) parts[i] = '0' + parts[i];
     }
    RE.linkBgColor = '#' + parts.join('');
}

RE.getEncodeHtml = function() {
    window.callback.getEncodeHtml(encodeURIComponent(RE.getHtml()));
}

RE.getHtml = function() {
    return RE.editor.innerHTML;
}

RE.getText = function() {
    return RE.editor.innerText;
}

RE.setBaseTextColor = function(color) {
    RE.editor.style.color  = color;
}

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.undo = function() {
    document.execCommand('undo', false, null);
}

RE.redo = function() {
    document.execCommand('redo', false, null);
}

RE.setBold = function() {
    document.execCommand('bold', false, null);
}

RE.detectBoldState = function() {
  var boldState = false;
  if(document.queryCommandState('bold')) {
    boldState = true;
  }
  callback.onTextBold(boldState)
}
RE.detectTextState = function() {
  var boldState = false;
  if(document.queryCommandState('bold')) {
    boldState = true;
  }

  var italicState = false;
  if(document.queryCommandState('italic')) {
    italicState = true;
  }

  var underlineState = false;
  if(document.queryCommandState('underline')) {
    underlineState = true;
  }
  callback.onTextStateChange(boldState, italicState, underlineState)
}
RE.onClick = function() {
    callback.onClick()
}

RE.setItalic = function() {
    document.execCommand('italic', false, null);
}

RE.detectItalicState = function() {
  var italicState = false;
  if(document.queryCommandState('italic')) {
    italicState = true;
  }
  callback.onTextItalic(italicState)
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
}

RE.setUnderline = function() {
    document.execCommand('underline', false, null);
}

RE.detectUnderlineState = function() {
  var underlineState = false;
  if(document.queryCommandState('underline')) {
    underlineState = true;
  }
  callback.onTextUnderline(underlineState)
}

RE.setBullets = function() {
    document.execCommand('InsertUnorderedList', false, null);
}

RE.setNumbers = function() {
    document.execCommand('InsertOrderedList', false, null);
}

RE.setTextColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
}

RE.setHeading = function(heading) {
    document.execCommand('formatBlock', false, '<h'+heading+'>');
}

RE.setIndent = function() {
    document.execCommand('indent', false, null);
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
}

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
}

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
}

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
}

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
}

RE.scrollToSelection = function() {
$('body').scrollTop($(window.getSelection().anchorNode).offset().top);
}

RE.scrollToSelectionExt = function() {
  $('body').scrollTop(RE.getRelativeCaretYPosition());
}

RE.insertImage = function(html,id,shouldScroll) {

  if(shouldScroll) {
    var $e;
     for (var i = 0; i < $(html).length; i++) {
          if ($(html).eq(i).is('img')) {
              $e = $(html).eq(i);
        }
    }
   $e[0].onload = function () {
       RE.scrollToSelectionExt();
    }
  }


    RE.insertHTML(html);

    $('#' + id).bind("DOMNodeRemoved", function(e)
   {
       console.log("DOMNodeRemoved: " + e.target.id);
       callback.cancelUploadMedia(id);
       callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
   });


}

RE.insertExpression = function(url, alt, width, height) {
       var html = '<img style="display:inline-block;width:' + width +  ';height:' + height + ';"  src="' + url + '" alt="' + alt + '" />';
    RE.insertHTML(html);

}

RE.setAttribute = function(blockId,key,value) {
  var block = document.getElementById(blockId);
  if(block != null) {
    block.setAttribute(key,value)
    callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
  }
}


RE.insertVideo = function(html,id) {
  $(html).ready(function () {
      RE.scrollToSelectionExt();
  })

  var sel = document.getSelection();

  var el = $(html)[0];

  var range = sel.getRangeAt(0).cloneRange();
  range.insertNode(el);
  range.setStartAfter(el);
  range.setEndAfter(el);
  sel.removeAllRanges();
  sel.addRange(range);
  range.insertNode($('<div><br></div>')[0]);


//  RE.insertHTML(html);

  //某些机型直接在标签里添加contenteditable会丢失，故采用以下这种方法
  var videoTag = document.getElementById(id);
  if(videoTag != null) {
    videoTag.setAttribute("contenteditable",false)
  }

  $('#' + id).bind("DOMNodeRemoved", function(e)
     {
         e.preventDefault();
         console.log("DOMNodeRemoved: " + e.target.id);
        if(e.target.id) {
             callback.cancelUploadMedia(id);
         }
         callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
    });
}

RE.insertHTML = function(html) {
    RE.restorerange();
    RE.Link.setLinkCursor();
    document.execCommand('insertHTML', false, html);

     var appBlocks = $('.app-wrap');
     if(appBlocks) {
        for(var i = 0; i < appBlocks.length; i++) {
        var appBlock = appBlocks[i];
        if(!appBlock.hasAttribute("contenteditable")) {
            appBlock.setAttribute("contenteditable","false")
         }
        }
     }
}

RE.deleteForward = function() {
    document.execCommand('delete', false, null);
}

function deleteElement(id) {
  var el = RE.editor;
  var range = document.createRange();
  range.selectNode(el);
  var sel = window.getSelection();
  sel.removeAllRanges();
  sel.addRange(range);
  document.execCommand("delete", false, null);
}

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length == 0) {
        document.execCommand("insertHTML",false,"<a href='"+url+"'>"+title+"</a>");
    } else if (sel.rangeCount) {
       var el = document.createElement("a");
       el.setAttribute("href", url);
       el.setAttribute("title", title);

       var range = sel.getRangeAt(0).cloneRange();
       range.surroundContents(el);
       sel.removeAllRanges();
       sel.addRange(range);
   }
    RE.callback();
}

RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function() {
    RE.backuprange();
}


RE.backuprange = function(){
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};
    }
}

RE.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
}

RE.getRelativeCaretYPosition = function() {
    var sel = window.getSelection();
    if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        range.collapse(false);
        var topPosition = -1;
//        if (!range.startContainer.offsetTop && range.startContainer.offsetTop != 0 ) {
            var span = document.createElement('span');// something happening here preventing selection of elements
            range.collapse(false);
            span.appendChild(document.createTextNode("  "))
            range.insertNode(span);
            topPosition = span.offsetTop
            span.parentNode.removeChild(span);
//        } else {
//            topPosition = range.startContainer.offsetTop + range.startContainer.offsetHeight ;
//        }
        return topPosition;
    }
    return -1
}

RE.getRange = function() {
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        return selection.getRangeAt(0);
    }
}

RE.getRangeClone = function() {
    var range = RE.getRange();
    if (typeof(range) == "undefined" || range == null) {
        return;
    }
    return range.cloneRange();
}

RE.selectNode = function(node) {
    if (typeof(node) == "undefined" || node == null) {
        return;
    }
    var range = RE.getRange();
    if (typeof(range) == "undefined" || range == null) {
            return;
    }
    range.selectNodeContents(node);
    RE.selectRange(range);
}

RE.selectRange = function(range) {
    if (typeof(range) == "undefined" || range == null) {
        return;
    }
    var sel = window.getSelection();
    sel.removeAllRanges();
    sel.addRange(range);
}

RE.saveRange = function() {
    RE.lastRange = RE.getRangeClone();
}

RE.enabledEditingItems = function(e) {
    var items = [];
    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    window.location.href = "re-state://" + encodeURIComponent(items.join(','));
}

RE.focus = function() {
//    var range = document.createRange();
//    range.selectNodeContents(RE.editor);
//    range.collapse(false);
//    var selection = window.getSelection();
//    selection.removeAllRanges();
//    selection.addRange(range);
    RE.editor.focus();
}

//用于重新定位光标位置，该方法有问题，会一直将光标定位到最后
RE.lastFocus = function() {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    RE.editor.focus();
}

RE.blurFocus = function() {
    RE.editor.blur();
}

RE.removeFormat = function() {
    execCommand('removeFormat', false, null);
}

/**
 *  从剪切板获取文本
 *  @params e 剪切板对象
 *  @return 是否已处理
 **/
RE.pasteNormalCallback = function(e) {
    var selection = window.getSelection();
    var range = selection.getRangeAt(0);
    if (event.clipboardData || event.originalEvent) {
        var clipboardData = (event.clipboardData || event.originalEvent.clipboardData);
        if(typeof(clipboardData) != "undefined" && clipboardData != null){
            var data;
            if(clipboardData.types.indexOf('text/html') > -1) {//html
                data = clipboardData.getData('text/html');
            } else if(clipboardData.types.indexOf('text/plain') > -1) {//无文本格式
                data = clipboardData.getData('text/plain');
            }
            if (null != data) {
                if (null != range) {
                   range.deleteContents();
                }
                window.location.href = "re-check://" + encodeURIComponent(data.replace(/\'/g, "\\\'"));
                e.preventDefault(); // We are already handling the data from the clipboard, we do not want it inserted into the document
                return true;
            }
            return false;
        }
    }
}

/**
 *  使用透明布局插入方式
 *  代码参照 https://github.com/wbb/wysibb/blob/master/jquery.wysibb.js#L837
 *  @params e 剪切板对象
 *  @return 是否已处理
 **/
RE.pasteSpecialCallback =  function(e) {
    var originScrollTop = $('body').scrollTop();
    if (!RE.editor.pasteBlock) {
        RE.saveRange();
        // append translate div
        RE.pasteBlock = document.createElement("div");
        RE.pasteBlock.setAttribute("style", "opacity:0;");
        RE.pasteBlock.setAttribute("contenteditable", "true");
        RE.pasteBlock.innerHTML = "\uFEFF";
        RE.editor.appendChild(RE.pasteBlock);

        window.setTimeout(function() {
            var data = '<span>'+ RE.pasteBlock.innerHTML+'</span>';
            RE.editor.removeChild(RE.pasteBlock);
            RE.editor.focus();

            RE.selectRange(RE.lastRange);

            window.location.href = "re-check://" + encodeURIComponent(data);

            RE.pasteBlock = null;
            RE.lastRange = null;

            $('body').scrollTop(originScrollTop);
        }, 1);
        RE.selectNode(RE.pasteBlock);
        return true;
    }
    return false;
}

// Event Listeners
RE.editor.addEventListener("input", RE.callback);
RE.editor.addEventListener("keyup", function(e) {
    var KEY_LEFT = 37, KEY_RIGHT = 39;
    if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
        RE.enabledEditingItems(e);
    }
});
RE.editor.addEventListener("click", RE.enabledEditingItems);
RE.editor.addEventListener("paste", function(e) {
    if (RE.pasteNormalCallback(e)) {
        return;
    }
    if (RE.pasteSpecialCallback(e)) {
        return;
    }
});


RE.videoProgress = function(id,percent,text) {
  var jsProgressPercent = document.querySelector('#' + id + ' .js-progress-percent');
  var jsPercent = document.querySelector('#' + id + ' .js-percent');
  var jsProgress = document.querySelector('#' + id + ' .js-progress');
  var jsPlayBtn = document.querySelector('#' + id + ' .js-play-btn');

  jsPercent.innerText = text;
  jsProgressPercent.style.width = percent + '%';
  if(percent == 100) {
     RE.closeVideo(id,function() {
//              callback.cancelUploadVideo(id);
//               callback.onReloadUrl(encodeURIComponent(RE.getHtml()))

        })
     RE.changeVideoCover(id,function(){
        callback.changeVideoCover(id);

     })
    jsProgress.parentNode.removeChild(jsProgress);	// 进度条隐藏
    jsPlayBtn.style.display = 'inline-block';
    callback.onReloadUrl(encodeURIComponent(RE.getHtml()))

  }
};

RE.closeVideo = function(id,callback) {
  var jsClose = document.querySelector('#' + id + ' .js-close');
  jsClose.style.display = 'inline-block'; 		// 删除按钮展示
  var wrap = document.querySelector('#' + id);
  jsClose.addEventListener('click', function () {
  						wrap.remove();
  						callback && callback();
  					});
}

RE.changeVideoCover = function(id,callback) {
  var jsUploadCover = document.querySelector('#' + id + ' .js-upload-cover');
    jsUploadCover.style.display = 'inline-block';  	// 修改封面展示
    jsUploadCover.addEventListener('click', callback);
}

RE.videoChangeCover = function(id,img) {
  var jsCover = document.querySelector('#' + id + ' .js-cover');
  if(jsCover != null) {
   jsCover.style.backgroundImage = 'url("' + img + '")'
  }
   callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
}

RE.videoUploadFailed = function(id) {
  var jsFailToAgain = document.querySelector('#' + id + ' .js-fail-to-again');
  var jsProgressWrap = document.querySelector('#' + id + ' .progress-wrap');
  var jsPercent = document.querySelector('#' + id + ' .js-percent');
  var jsProgressPercent = document.querySelector('#' + id + ' .js-progress-percent');
  jsFailToAgain.style.display = 'block';  	// 上传失败提示
  jsProgressWrap.style.display = 'none';
  jsPercent.innerText = '';
  jsProgressPercent.style.width = '0%';

  jsFailToAgain.addEventListener('click', function() {
     jsFailToAgain.style.display = 'none';
      jsProgressWrap.style.display = 'block';
      callback.onRetryUploadVideo(id);
  });

   callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
}



    function EditorLink (cardEditCallback, linkEditCallback, confirmCallback, cancelCallback) {
        this.init();
        this.handler();
    }

    EditorLink.prototype = {
        init: function () {

            this.bgColor = '#F8F8F8';
            this.mainTitleColor = '#ff333333'
            this.subTitleColor = '#ff999999'
            this.ajaxUrl = null;
            this.lastRange = null;	// 用来记录最后一次光标位置

            this.jEditor = document.querySelector('#editor');
            this.jsIconModal = document.querySelector('.js-icon-modal');	// 小弹框的编辑按钮
            this.jsIconModalCard = document.querySelector('.js-icon-modal-card');
            this.jsChangeToCard = document.querySelector('.js-change-to-card'); 	// 小弹框的切换卡片按钮
            this.jsChangeToLink = document.querySelector('.js-change-to-link'); 	// 小弹框的切换链接按钮
            this.jsEditorLinkButton = document.querySelector('.js-editor-link-button');
            this.jsEditorCardButton = document.querySelector('.js-editor-card-button');
        },

        handler: function () {
            var _this = this;
            this.jsIconModalCard.addEventListener('touchend', this.cardEditCallback.bind(this))
            this.jsIconModal.addEventListener('touchend', this.linkEditCallback.bind(this))

            this.jsChangeToCard.addEventListener('touchend', function (e) {
                var node = _this.getSelectNode();
                var aNode = _this.getA(node);

                var range1 = document.createRange();
                range1.selectNodeContents(aNode);
//                range1.collapse(true);

                var sel = window.getSelection();
                sel.removeAllRanges();
                sel.addRange(range1)

                if (document.queryCommandState('bold')) {
                  document.execCommand('bold', false, null);
                }

                if (document.queryCommandState('italic')) {
                  document.execCommand('italic', false, null);
                }

                var href = aNode.href.replace(/file:\/\/\/android_asset\/(.+)/,"$1");


                var cardNode = _this.createCardNode(href, aNode.innerText);

                _this.jsEditorLinkButton.style.display = 'none';
                _this.jsEditorCardButton.style.display = 'none';

                var bn = sel.baseNode;
                $(bn).closest('a').replaceWith(cardNode);

                if (!$($(cardNode)[0].nextSibling).is('br')) {
                  $(cardNode).after('<br>')
                }

                var id = $(cardNode).attr('data-id');
                // javaCallback todo
                	callback.onLinkChangeToCard(href,aNode.innerText,id)

            })

            this.jsChangeToLink.addEventListener('touchend', function (e) {
                var node = _this.getSelectNode();
                var aNode = _this.getA(node);

                if (aNode) {
                    var node = document.createElement('a');

                    var word = aNode.querySelector('.left-word').innerText;
                    var url = aNode.querySelector('.left-url').innerText;
                    node.innerText = word;
                    node.href = url;

                    aNode.remove();

                    var rng = _this.getRange();
                    rng.insertNode(node);
                    rng.setStartAfter(node);
                    rng.setEndAfter(node);
                    if (!$($(node)[0].previousSibling).is('br')) {
                      $(node).before('<br>');
                    }
                    if (!$($(node)[0].nextSibling).is('br')) {
                      $(node).after('<br>');
                    }
                }
                _this.jsEditorLinkButton.style.display = 'none';
                _this.jsEditorCardButton.style.display = 'none';


                // 这里请求接口抓取这个 url 的相关数据，并重新渲染上去。
            })

//            this.jEditor.addEventListener("click", this.clickHandler.bind(this), false);
            document.addEventListener("selectionchange", function (e) {
              var node = _this.getSelectNode();
              var aNode = _this.getA(node);
              $(_this.jEditor).find('.acvite').removeClass('active');
              $('.card').removeClass('active');
              _this.jsEditorLinkButton.style.display = 'none';
              _this.jsEditorCardButton.style.display = 'none';
              if (aNode) {
                if (aNode.className.indexOf('card') > -1) {
                  aNode.classList.add('active');
                  _this.setCardSelectionPosition(aNode);
                } else {
                  _this.setLinkSelectionPosition(aNode);
                }
              } else {
                _this.jsEditorLinkButton.style.display = 'none';
                _this.jsEditorCardButton.style.display = 'none';
              }

            });
        },

       cardEditCallback: function(e) {
       				this.jEditor.focus();
       				this.saveRange();

       				var node = this.getSelectNode();
       				var aNode = this.getA(node);

       				var obj = {};
       				if (aNode) {
       				 var id;
               	if ($(aNode).attr('data-id')) {
                     		id = $(aNode).attr('data-id')
                  } else {
                     	id = new Date().getTime().toString(16);
                      $(aNode).attr('data-id', id);
                }
       					var url = $(aNode).find('.left-url').text().replace(/file:\/\/\/android_asset\/(.+)/,"$1");
       					var word = $(aNode).find('.left-word').text();
       					// javaCallback todo
       					callback.onLinkEdited(url,word,id,true)
       				}
       			},

       			linkEditCallback: function(e) {
       				this.jEditor.focus();
       				this.saveRange();

       				var node = this.getSelectNode();
       				var aNode = this.getA(node);

       				var obj = {};
       				if (aNode) {
       					var id;
       					if ($(aNode).attr('data-id')) {
       						id = $(aNode).attr('data-id')
       					} else {
       						id = new Date().getTime().toString(16);
       						$(aNode).attr('data-id', id)
       					}

       					var url = aNode.href.replace(/file:\/\/\/android_asset\/(.+)/,"$1");
       					var word = aNode.innerText;
       					// javaCallback
       					callback.onLinkEdited(url,word,id,false)
       				}

       			},

				createCardNode: function (url, word) {
				      var _this = this;
      				var cardNode = document.createElement('a');
      				var id = new Date().getTime().toString(16);
      				cardNode.setAttribute('data-id', id);

      				cardNode.setAttribute('contenteditable', false);
      				cardNode.setAttribute('link-url',url);
      				cardNode.classList.add('card');

      				var cardLeftNode = document.createElement('div');
      				cardLeftNode.classList.add('left');
      				var cardLeftWordNode = document.createElement('div');
      				cardLeftWordNode.classList.add('left-word');
      				var cardLeftUrlNode = document.createElement('div');
      				cardLeftUrlNode.classList.add('left-url');
      				cardLeftNode.appendChild(cardLeftWordNode);
      				cardLeftNode.appendChild(cardLeftUrlNode);

      				var cardRightNode = document.createElement('div');
      				cardRightNode.classList.add('right');

      				var cardImage = document.createElement('img');
      				cardImage.src = 'file:///android_res/drawable/link_card_default_icon.png';
      				cardRightNode.appendChild(cardImage)

      				var closeBtn = document.createElement('img');
      				closeBtn.classList.add('close-btn');
      				closeBtn.src = 'file:///android_res/drawable/editor_video_close.png';


      				cardLeftWordNode.innerText = word;
      				cardLeftUrlNode.innerText = url;

      				cardNode.appendChild(cardLeftNode);
      				cardNode.appendChild(cardRightNode);	// 这部分是渲染 card 的
      				cardNode.appendChild(closeBtn);

      				if(cardNode.style.background) {
      			    	this.bgColor = cardNode.style.background
      				}


              if(RE.linkBgColor) {
                  cardNode.style.background = RE.linkBgColor;
              } else {
                cardNode.style.background = this.bgColor;
              }



              cardLeftWordNode.style.color = this.mainTitleColor;
              cardLeftUrlNode.style.color = this.subTitleColor;

      				closeBtn.addEventListener('click', function () {
      					cardNode.remove();
      					_this.jsEditorLinkButton.style.display = 'none';
                _this.jsEditorCardButton.style.display = 'none';
      				})

      				return cardNode;
      			},


      insertTextToHead: function (text) {  // text 就是你要插入的文字
                    this.jEditor.focus()
            				this.getRange().setStart(this.jEditor, 0);
            				this.getRange().collapse(true);

            				var node = document.createTextNode(text);
            				this.getRange().insertNode(node);
            				this.getRange().setStartAfter(node)
            				this.getRange().setEndAfter(node)
            				this.getRange().insertNode($('<br>')[0]);
            				this.getRange().setStartAfter(node)
                    this.getRange().setEndAfter(node)
                    this.getRange().collapse(true);
            				this.jEditor.focus()

            				callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
            			},


       modalConfirm: function (url, word, type,bgColor,mainTitleColor,subTitleColor) {
              this.bgColor = bgColor;
              this.mainTitleColor = mainTitleColor;
              this.subTitleColor = subTitleColor;

       				if (type == 'card') {
       					var aNode = this.createCardNode(url, word);
//       					var br = document.createElement('br');
       				} else {
       					var aNode = document.createElement('a');
       					aNode.href = url;
       					aNode.innerText = word;
       				}

       				if (this.lastRange) {
       					var commonAncestorContainer = this.lastRange.commonAncestorContainer;
       				} else {
       					var commonAncestorContainer = this.getRange().commonAncestorContainer;
       				}

       				var node = this.getA(commonAncestorContainer);
       				console.log(node);
       				if (node) {		// 这里是为了判断当前光标位置是否是 dom a 的位置，如果是 那么弹框确定之后就需要替换当前的 a 的内容
       					node.remove();
       				} else {
       					this.lastRange.deleteContents();
       				}

       				this.lastRange.insertNode(aNode);
       				this.lastRange.setStartAfter(aNode);
       				this.lastRange.setEndAfter(aNode);

       				this.selectRange();
       				this.jEditor.focus();	// 设置上之后再次获得焦点
       				 callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
       			},

       			changeTitle: function(id, url, word, type,bgColor,mainTitleColor,subTitleColor) {
       			  var selector = '[data-id=' + id + ']'
              if (id && $(selector).length > 0) {
                $(selector).find('.left .left-word').text(word);
                callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
              }
       			},

        saveRange: function () {	// 保存点击添加按钮之前最后的光标位置
            this.lastRange = this.getRange().cloneRange();
        },

        getRange: function () {	//
        			  var selection = window.getSelection();
                  if (selection.rangeCount > 0) {
                      return selection.getRangeAt(0);
                }
       },

        getSelectNode: function () { // 获取光标位置的 dom
            var rng = this.getRange();
            if (rng) {
              return (window.getSelection) ? rng.commonAncestorContainer : rng.parentElement();
            }
        },

        getA: function (node) {	// 获取 dom a
            while (node && node.className != 'editor') {
                if (node.tagName && node.tagName.toLowerCase() == 'a') {
                    return node;
                }

                if (node) {
                    node = node.parentNode;
                } else {
                    return null;
                }
            }
        },

      	setLinkSelectionPosition: function (node) {					// 设置点击链接之后的小弹框的位置
      	    this.jsIconModal.innerText  = RE.localizationText.edit;
      	    this.jsIconModalCard.innerText  = RE.localizationText.edit;
            this.jsChangeToCard.innerText = RE.localizationText.switchCard;
            this.jsChangeToLink.innerText = RE.localizationText.switchLink;

      				this.jsEditorLinkButton.style.display = 'block';
              var editorWidth = this.jEditor.offsetWidth;
              var linkSelectionLeft = this.jEditor.offsetWidth - node.offsetLeft;
              var jsEditorLinkButtonWidth = this.jsEditorLinkButton.offsetWidth;

      				if (linkSelectionLeft < jsEditorLinkButtonWidth) {
                // 这个是链接位于右边的时候
                this.jsEditorLinkButton.style.left = 'auto';
                this.jsEditorLinkButton.style.right = (0 - jsEditorLinkButtonWidth/2 + 10) + 'px';
              } else {
                this.jsEditorLinkButton.style.right = 'auto';
                this.jsEditorLinkButton.style.left = (node.offsetLeft + node.offsetWidth/2 <
                jsEditorLinkButtonWidth/2 ? (jsEditorLinkButtonWidth/2 + 10) : node.offsetLeft +
                node.offsetWidth/2) + 'px';
              }

              this.jsEditorLinkButton.style.top = node.offsetTop + node.offsetHeight + 'px';

      			},

    setCardSelectionPosition: function (node) {					// 设置点击链接块之后的小弹框的位置
      				console.log(node.offsetTop, node.offsetLeft);
      				this.jsEditorCardButton.style.display = 'block';
      				this.jsEditorCardButton.style.left = (node.offsetLeft + node.offsetWidth/2 < 75 ? 75 : node.offsetLeft + node.offsetWidth/2) + 'px';

      				if (node.offsetTop < 44) {
      					this.jsEditorCardButton.style.top = node.offsetTop + node.offsetHeight + 4 + 'px';
      					this.jsEditorCardButton.classList.remove('top');
      					this.jsEditorCardButton.classList.add('bottom');
      				} else {
      					this.jsEditorCardButton.style.top = node.offsetTop - 44 + 'px';
      					this.jsEditorCardButton.classList.remove('bottom');
      					this.jsEditorCardButton.classList.add('top');
      				}
      			},

        selectRange: function () {	// 编辑器失去焦点重新 focus 之前，将上次光标的位置设置上
            var sel = window.getSelection();
            sel.removeAllRanges();
            sel.addRange(this.lastRange);
        },

        setGetValue: function (url, word, img, id,json) {
        		var selector = '[data-id=' + id + ']'
        		if (id && $(selector).length > 0) {
                  $(selector).attr('data-json',json)
                   $(selector).attr('link-url',url)
        					$(selector).find('.left .left-word').text(word);
        					$(selector).find('.left .left-url').text(url);
        					$(selector).find('.right img').attr('src', img);
        					callback.onReloadUrl(encodeURIComponent(RE.getHtml()))
        				}
        			},

        setLinkCursor: function() {
        			var sel = window.getSelection();
        			var rng = this.getRange();
        			var isInLink = sel.baseNode && sel.baseNode.parentNode && sel.baseNode.parentNode.nodeName && sel.baseNode.parentNode.nodeName == 'A';
              var node = sel.baseNode ? sel.baseNode.parentNode : '';
        	     if (isInLink) {
        	          rng.setStartAfter(node);
        	          rng.setEndAfter(node);
        	          rng.collapse(false);
        	          sel.removeAllRanges();
                    sel.addRange(rng);
        	     }
        		}
    }

 RE.Link = new EditorLink()

 RE.insertLink = function(title,url,bgColor,mainTitleColor,subTitleColor) {
   RE.Link.saveRange()
   RE.Link.modalConfirm(url,title,"url",bgColor,mainTitleColor,subTitleColor)
 }

 RE.updateCardLink = function(title,url,bgColor,mainTitleColor,subTitleColor) {
   RE.Link.modalConfirm(url,title,"card",bgColor,mainTitleColor,subTitleColor)
 }

 RE.changeTitle = function(id,title,url,bgColor,mainTitleColor,subTitleColor) {
   RE.Link.changeTitle(id, url,title,"card",bgColor,mainTitleColor,subTitleColor)
 }

 RE.updateUrlLink = function(title,url,bgColor,mainTitleColor,subTitleColor) {
   RE.Link.modalConfirm(url,title,"url",bgColor,mainTitleColor,subTitleColor)
 }

 RE.changeToCard = function(title,url,img,id,json) {
   RE.Link.setGetValue(url,title,img,id,json)
 }

 RE.insertTextToHead = function(text) {
  RE.Link.insertTextToHead(text)
 }

// 通过该方法注入多语言数据，这不是一个最优解，因为是异步注入，但是目前可以实现的一种简易方案。
// 如果是在初始化就需要用到多语言的话，该方法是无法满足的。
RE.injectLocalizationText = function(text) {
  RE.localizationText = text
}

